class AutoMap extends Map {
	constructor(fallbackHandler) {
		super()
		this.fallbackHandler = fallbackHandler
	}
	get(key) {
		if (super.has(key)) return super.get(key)
		const value = this.fallbackHandler(key)
		super.set(key, value)
		return value
	}
}
class AutoWeakMap extends WeakMap {
	constructor(fallbackHandler) {
		super()
		this.fallbackHandler = fallbackHandler
	}
	get(key) {
		if (super.has(key)) return super.get(key)
		const value = this.fallbackHandler(key)
		super.set(key, value)
		return value
	}
}
export { AutoMap, AutoWeakMap }
