async function asyncReplace(string, regexp, replacer) {
	const promises = []
	string.replace(regexp, (match, ...arguments_) => {
		promises.push(replacer(match, ...arguments_))
		return match
	})
	const strings = await Promise.all(promises)
	let index = 0
	return string.replace(regexp, () => strings[index++])
}
export { asyncReplace }
