import { readdir } from "fs/promises"
async function findFiles(path, filter = [], paths = []) {
	const filterFunction = Array.isArray(filter) ? name => !filter.includes(name) : filter
	await Promise.all(
		(await readdir(path, { withFileTypes: !0 })).map(async dirent => {
			if (!filterFunction(dirent.name)) return
			const direntPath = `${path}/${dirent.name}`
			dirent.isDirectory() ?
				await findFiles(direntPath, filterFunction, paths)
			:	dirent.isFile() && paths.push(direntPath)
		})
	)
	return paths
}
export { findFiles }
