import { isRecord } from "./isRecord.js"
function getDeepObjectProperty(object, keys) {
	const lastKey = keys.pop()
	if (!lastKey) return object
	for (const key of keys) {
		const child = object[key]
		if (!isRecord(child)) throw Error("Expected object, got " + typeof child)
		object = child
	}
	return object[lastKey]
}
export { getDeepObjectProperty }
