export declare function mapIterable<T, R>(iterable: Iterable<T>, callback: (item: T) => R): Generator<R, void, never>;
export declare function filterIterable<T>(iterable: Iterable<T>, callback: (item: T) => boolean): Generator<T, void, never>;
export declare function toGenerator<T>(iterable: Iterable<T>): Generator<T, void, never>;
export declare function iterateInParallel<A, B>(firstIterable: Iterable<A>, secondIterable: Iterable<B>): Generator<[A, B], void, never>;
export declare function asyncIterableToArray<T>(asyncIterable: AsyncIterable<T>): Promise<T[]>;
/** For merging async iterators concurrently.
  * @param asyncIterators Array of async iterators
  * @returns An async generator that iterates through {@link asyncIterators} concurrently */
export declare function mergeAsyncIterators<T>(asyncIterators: AsyncIterator<T, void, never>[]): AsyncGenerator<T, void, never>;
