import { assert } from "./assert.js"
import { countBigIntBits } from "./countBigIntBits.js"
function fromBigInt(integer) {
	const u8View = new Uint8Array(Math.ceil(Number(countBigIntBits(integer) || 1) / 7))
	for (const byteIndex of u8View.keys())
		u8View[byteIndex] = Number(((integer >> (7n * BigInt(byteIndex))) & 0b01111111n) | 0b10000000n)
	u8View[u8View.length - 1] = 127 & u8View.at(-1)
	return u8View
}
function toBigInt(u8View, index = { $: 0 }) {
	let result = 0n,
		offset = 0n
	for (;;) {
		const byte = u8View[index.$++]
		assert(null != byte, "src/leb128.ts:22:29")
		result |= (0b01111111n & BigInt(byte)) << offset
		offset += 7n
		if (!(128 & byte)) return result
	}
}
export { fromBigInt, toBigInt }
