const defaultArgumentComparerFunction = (a, b) => a.length == b.length && a.every((aItem, index) => aItem == b[index])
function memoizeFunction(function_, argumentComparerFunction = defaultArgumentComparerFunction) {
	const memos = []
	return (...arguments_) => {
		const foundMemo = memos.find(memo => argumentComparerFunction(memo.arguments, arguments_))
		if (foundMemo) return foundMemo.returnValue
		const newMemo = { arguments: arguments_, returnValue: function_(...arguments_) }
		memos.push(newMemo)
		return newMemo.returnValue
	}
}
export { memoizeFunction }
