async function* raceAllPromises(promises) {
	const promisesIndex = promises.map(promise => {
		const newPromise = promise.then(value => ({ value, promise: newPromise }))
		return newPromise
	})
	for (; promisesIndex.length; ) {
		const { value, promise } = await Promise.race(promisesIndex)
		yield value
		promisesIndex.splice(promisesIndex.indexOf(promise), 1)
	}
}
export { raceAllPromises }
