let currentEffect
function createSignal(value) {
	const listeners = new Set()
	return [
		() => {
			currentEffect && listeners.add(currentEffect)
			return value
		},
		newValue => {
			if (currentEffect) throw Error("Must not use signal setter inside an effect")
			if (!Object.is(value, newValue)) {
				value = newValue
				for (const listener of [...listeners]) createEffect(listener)
			}
		}
	]
}
function createEffect(effect) {
	const outerEffect = currentEffect
	currentEffect = effect
	effect()
	currentEffect = outerEffect
}
function createMemo(getter) {
	const listeners = new Set()
	let value,
		changed = !0
	const effect = () => {
		changed = !0
		for (const listener of [...listeners]) createEffect(listener)
	}
	return () => {
		currentEffect && listeners.add(currentEffect)
		if (changed) {
			const outerEffect = currentEffect
			changed = !1
			currentEffect = effect
			value = getter()
			currentEffect = outerEffect
		}
		return value
	}
}
export { createEffect, createMemo, createSignal }
