import type { LaxPartial } from ".";
export type RetryOptions = {
    attempts: number;
    retryDelay: number;
    onError: (error: unknown) => void;
    exponentialBackoff: boolean;
};
/** @example const response = await retry(() => fetch(url, fetchOptions)) */
export declare function retry<T>(callback: () => Promise<T>, { attempts, retryDelay, onError, exponentialBackoff }?: LaxPartial<RetryOptions>): Promise<T>;
